﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace LAB16
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //globális változók
        string filenev = "..\\..\\targy.txt";
        string kepnev = @"..\..\mogi.png";
        Bitmap bm;

        const int maxpsz = 100;
        int[] gyakorisag = new int[maxpsz + 1];

        Pen toll = new Pen(Color.Black);
        SolidBrush ecset = new SolidBrush(Color.Red);
        Font font = new Font("Arial", 10);
        Color szin = Color.Azure;
        Image kep;


        // Inicializálás
        private void Form1_Load(object sender, EventArgs e)
        {
            Text = "Grafika";
            button1.Text = "Adatok betöltése";
            button2.Text = "Kép mentése";
            button3.Text = "Kilépés";

            if (File.Exists(kepnev)) //kép meglétének ellenörzése
            {
                bm = new Bitmap(kepnev); //kép meglétének ellenőrzése
                pictureBox1.Image = bm;  //kép betöltése a pictureboxba
                pictureBox1.Width = bm.Width;
                pictureBox1.Height = bm.Height;
            }
        }

        // Betöltés gomb
        private void button1_Click(object sender, EventArgs e)
        {
            feldolgoz();
        }


        // Fájl adatainak betöltése és feldolgozása
        void feldolgoz()
        {
            //gyakoriság törlése
            for (int i = 0; i < gyakorisag.Length; i++)
            {
                gyakorisag[i] = 0;
            }

            //ha nem létezik a fájl, akkor kilépünk
            if (!File.Exists(filenev)) return;

            //ha létezik a fájl
            StreamReader streamReader = new StreamReader(filenev);

            while (!streamReader.EndOfStream)     //a fájl végéig olvas
            {
                string line = streamReader.ReadLine();   //az egész sor kiolvasása
                if (!line.Contains('\t')) continue;  // nincs benne a pontszám

                string szam = line.Substring(line.IndexOf("\t") + 1); //csak a szám
                int psz = Convert.ToInt32(szam);
                gyakorisag[psz]++; //a pontszám szerinti gyakoriságot növelem eggyel
            }

            streamReader.Close();

            rajz();    //kirajzolom

        }

        //  Rajzolás
        void rajz()
        {
            Bitmap bitmap = new Bitmap(pictureBox2.Width, pictureBox2.Height);
            Graphics gr = Graphics.FromImage(bitmap);

            //gr.Clear(Color.Red);
            int w = pictureBox2.Width - 1;
            int h = pictureBox2.Height - 1;
            float dx = (float)w / (maxpsz + 1);

            ecset.Color = szin;
            gr.FillRectangle(ecset, 0, 0, w, h);
            gr.DrawRectangle(toll, 0, 0, w, h);

            int hmax = gyakorisag.Max();

            for (int i = 0; i < gyakorisag.Length; i++)
            {
                float szam = gyakorisag[i];
                if (hmax != 0) szam *= (float)h / hmax;

                if (i < 40) ecset.Color = Color.Silver;
                else if (i < 55) ecset.Color = Color.Red;
                else if (i < 70) ecset.Color = Color.Yellow;
                else if (i < 85) ecset.Color = Color.GreenYellow;
                else ecset.Color = Color.Green;

                gr.FillRectangle(ecset, i * dx, h - szam, dx, szam);
                gr.DrawRectangle(toll, i * dx, h - szam, dx, szam);
            }

            gr.DrawString("Eredmeny 2023", font, ecset, 10, 10);

            kep = new Bitmap(kepnev);
            gr.DrawImage(kep, w - kep.Width - 10, 10);


            pictureBox2.Image = bitmap;

        }

        // Mentés gomb
        private void button2_Click(object sender, EventArgs e)
        {
            pictureBox2.Image.Save("kep.png");
        }

        // Kilépés gomb
        private void button3_Click(object sender, EventArgs e)
        {
            Close();
        }

        // Átméretezéskor rajzolja ki
        private void Form1_Resize(object sender, EventArgs e)
        {
            rajz();
        }

        // Bal és jobb egérgomb lenyomása
        private void pictureBox2_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                ColorDialog cld = new ColorDialog();
                cld.Color = szin;
                cld.ShowDialog();
                szin = cld.Color;
            }
            if (e.Button == MouseButtons.Right)
            {
                FontDialog fd = new FontDialog();
                fd.Font = font;
                fd.ShowDialog();
                font = fd.Font;
            }

            rajz();
        }
    }
}
